﻿using System;

namespace ChainOfResponsability.Ejm1
{
    /// <summary>
    /// Jefe de sucursal
    /// </summary>
    public class BranchManager : PRHandler
    {
        private const double Limit = 25000;

        public BranchManager(string name)
            : base(name)
        {
        }

        public override bool Authorize(PurchaseRequest request)
        {
            double amount = request.GetAmount();
            if (amount <= Limit)
            {
                Console.WriteLine("Branch Manager " + getName()
                        + " has authorized the PR  " + request);
                return true;
            }
            else
            {
                // forward the request to the next handler
                return GetNextHandler().Authorize(request);
            }
        }
    }
}
