﻿using System;
namespace ChainOfResponsability.Ejm1
{
    /// <summary>
    /// Presidente y Coordinador
    /// </summary>
    public class PresidentCOO : PRHandler
    {
        private const double Limit = 400000;

        public PresidentCOO(String name)
            : base(name)
        {
        }

        public override bool Authorize(PurchaseRequest request)
        {
            double amount = request.GetAmount();
            if (amount <= Limit)
            {
                Console.WriteLine("President & COO " + getName()
                        + " has authorized the PR  " + request);
                return true;
            }
            else
            {
                Console.WriteLine("PR - " + request
                        + " couldn't be authorized. "
                        + "Executive Board needs to be "
                        + "consulted for approval " + "reason: Amount too large");
                return false;
            }
        }
    }
}
