﻿using System;
namespace ChainOfResponsability.Ejm1
{
    public class VicePresident : PRHandler
    {
        private const double Limit = 200000;

        public VicePresident(String name)
            : base(name)
        {
        }

        public override bool Authorize(PurchaseRequest request)
        {
            double amount = request.GetAmount();
            if (amount <= Limit)
            {
                Console.WriteLine("V.P. " + getName()
                        + " has authorized the PR  " + request);
                return true;
            }
            else
            {
                // forward the request to the next handler
                return GetNextHandler().Authorize(request);
            }
        }
    }

}
